!
! *** calcula fracoes molares e massicas resultantes
!     da combustao de H2/O2 e a temperatura de chama
!     adiabatica com e sem dissociacao qumica
!
!     Marchi - UFSC - 29 Ago 97
!
!                                ltima alterao = 5 Set 97

      use msflib
	  use dados


      parameter  ( j = 103  )


      implicit real*8(a-h,o-z)
	  logical chamada,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10
      real*8 mh,mo,mh2o,mo2,mh2,moh,mtotalp(0:j),      &
             ntotalp(0:j),mtotalr(0:j),ntotalr(0:j),      &
			 n(6,j),nt(j),mtp(j),mol(6)
      dimension yo2r(0:j),yh2r(0:j),    	&
                yh2o(0:j),yo2(0:j),yh2(0:j),fmo2r(0:j),	    &
                fmh2r(0:j),fmh2o(0:j),fmo2(0:j),	&
                fmh2(0:j),a(0:j),e(0:j),f(0:j),g(0:j),	&
				of(0:j),tad(0:j),tad2(j),xd(4,j),fm(6,j),at(6,7,2),    &
				hz(6)

      open(21,file='user',title='APRESENTAO')
	  write(21,90)
   90 format(/,10x,'GUA - 5 Set 97',                           &
            //, 4x,'Calcula nmero de moles, fraes molares e',  &
			 /, 4x,'mssicas, e temperatura de chama adiabtica,', & 
			 /, 4x,'com e sem dissociao qumica,',  &
			 /, 4x,'resultantes da reao H2/O2.',  &
			//,10x,'Carlos Henrique Marchi')
	  read(21,*)
	  close(21)

      open(20,file='agua.dat',form='formatted')
	  call coeficientes(mol,hz,at)
	  close(20)

      runiv=8.314510d0

	  hh2l = - 9016.0d0
	  ho2l = -12984.0d0

      mh2o = mol(1)
      mo2 = mol(2)
	  mh2 = mol(3)
      mh = mol(4)
      mo = mol(5)
	  moh = mol(6)


1001 continue

      open(8,file='saida',form='formatted')
	  open(9,file='tad.dat',form='formatted')
	  open(10,file='fmx.dat',form='formatted')
      open(12,file='user',title='EXECUO DOS CLCULOS')
	  open(14,file='mol.dat',form='formatted')
	  open(15,file='fmos.dat',form='formatted')
	  open(16,file='fmas.dat',form='formatted')
	  open(17,file='fmoc.dat',form='formatted')
	  open(18,file='fmac.dat',form='formatted')


      call DoDialog(n1,n2,nitm1,nitm2,fofmin,fofmax,pt,tol1,tol2,   &
                    cr1,cr2,cr3,cr4)

      tcpui = timef()
     
      nmax = n1 + n2 + 3     


      do i = 0,nmax

! --- para combustao completa
      if(i.eq.0.or.i.eq.n1+2) &
	    call caso1(a(i),e(i),f(i),g(i))

! --- combustao com excesso de H2
      if(i.ge.1.and.i.le.n1+1) then
        ofmin=fofmin*ofs 
        dof = (ofs-ofmin)/(n1+1)
        of(i) = ofmin + (i-1)*dof
		a(i) = of(i)*mh/mo
        call caso2(a(i),e(i),f(i),g(i))
      end if

! --- combustao com excesso de O2
      if(i.gt.n1+2.and.i.le.nmax) then
        ofmax=fofmax*ofs 
        dof = (ofmax-ofs)/(n2+1)
        of(i) = ofs + (i-n1-2)*dof
		a(i) = of(i)*mh/mo
        call caso3(a(i),e(i),f(i),g(i))
      end if

      ntotalp(i) = e(i) + f(i) + g(i)

      mtotalp(i) = (e(i)*mh2o + f(i)*mo2 + g(i)*mh2)/ntotalp(i)

      ntotalr(i) = 1.0d0 + a(i)
      mtotalr(i) = (mh2 + a(i)*mo2)/ntotalr(i)

      yh2o(i) = e(i)/ntotalp(i)
      yo2(i) = f(i)/ntotalp(i)
      yh2(i) = g(i)/ntotalp(i)
      yh2r(i) = 1.0d0/ntotalr(i)
      yo2r(i) = a(i)/ntotalr(i)

      fmh2o(i) = yh2o(i)*mh2o/mtotalp(i)
      fmo2(i) = yo2(i)*mo2/mtotalp(i)
      fmh2(i) = yh2(i)*mh2/mtotalp(i)
      fmh2r(i) = yh2r(i)*mh2/mtotalr(i)
      fmo2r(i) = yo2r(i)*mo2/mtotalr(i)

      wo2 = a(i)*mo2
      wh2 = mh2
      of(i) = wo2/wh2

      if(i.eq.0) ofs = of(i)

      of(i)=of(i)/ofs

      hr = 1.0d0*hh2l + a(i)*ho2l
!      hr = e(i)*hz(1)*runiv

      call t_adiabatica_sem_dissociacao &
	    (e(i),f(i),g(i),hr,tad(i),nitm1,tol1,runiv,at)

! i = n1+2 = estequiomtrico
      if(i.ge.1) then
      call t_adiabatica_com_dissociacao                   &
	     (hr,tad2(i),pt,e(i),f(i),g(i),                   &
		  xd(1,i),xd(2,i),xd(3,i),xd(4,i),                &
		  n(1,i),n(2,i),n(3,i),n(4,i),n(5,i),n(6,i),      &
		  nt(i),nitm1,tol1,nitm2,tol2,runiv,at,cr1,cr2,cr3,cr4)
		  fm(1,i)=n(1,i)*mh2o/nt(i)
		  fm(2,i)=n(2,i)*mo2/nt(i)
		  fm(3,i)=n(3,i)*mh2/nt(i)
		  fm(4,i)=n(4,i)*mh/nt(i)
		  fm(5,i)=n(5,i)*mo/nt(i)
		  fm(6,i)=n(6,i)*moh/nt(i)
		  mtp(i) = 0.0d0
		  do l=1,6
		    mtp(i)=mtp(i)+fm(l,i)
	      end do
		  do l=1,6
		    fm(l,i)=fm(l,i)/mtp(i)
		  end do
          write(12,71) i,nmax
   71     format(2x,'Pontos j processados =',i3,' de',i4)
      end if

      end do

	  tcpuf=timef()

	  write(12,72) tcpuf-tcpui
	  write(8,72) tcpuf-tcpui
   72 format(//,5x,'Tempo de processamento (s) = ',1pe10.2,\)
      read(12,*)
	  close(12)

      write(8,40) fofmin,fofmax,n1,n2,pt,nitm1,tol1,nitm2,tol2,cr1,cr2,cr3,cr4
   40 format(///,20x,'DADOS',///,                                 &
                  5x,'Razao entre O/F mnimo e estequiometrico = ',1pe12.4,//, &
                  5x,'Razao entre O/F maximo e estequiometrico = ',1pe12.4,//, &
                  5x,'N.pontos entre O/F minimo e estequiometrico = ',i5,//,   &
                  5x,'N.pontos entre O/F estequiometrico e maximo = ',i5,//,   &
                  5x,'Pressao total do sistema (atmosferas) = ',1pe12.4,//,    &
                  5x,'N.mximo de iteraes para T adiabtica    = ',i6,//,    &
                  5x,'Tolerncia na entalpia para T adiabtica = ',1pe12.4,//, &
                  5x,'N.mximo de iteraes para nmero de moles = ',i6,//,    &
                  5x,'Tolerncia no nmero de moles            = ',1pe12.4,//, &
                  5x,'Ativao da reao de dissociao 1 = ',1pe12.4,/,	   &
                  5x,'Ativao da reao de dissociao 2 = ',1pe12.4,/,	   &
                  5x,'Ativao da reao de dissociao 3 = ',1pe12.4,/,	   &
                  5x,'Ativao da reao de dissociao 4 = ',1pe12.4,//)
   
      write(8,30) ofs
   30 format(///,10x,'O/F estequiomtrico =',1pe15.5,/)

      write(8,20)
   20 format(/////,20x,'RESULTADOS SEM DISSOCIACAO',////,     &
        10x,'COEFICIENTES ESTEQUIOMETRICOS',//,		          &
         3x,'o/f ',5x,' nh2r ',5x,'no2r',6x,'nh2o',6x,'no2 ', &
         6x,'nh2 '                                            &
         4x,'ntotalr ',2x,'ntotalp')
      do i=1,nmax
      write(8,21) of(i),1.0,a(i),e(i),                   &
                  f(i),g(i),ntotalr(i),ntotalp(i)
      end do
   21 format(8(1pe10.2))

      write(8,22)
   22 format(//,10x,'FRACOES MOLARES',//,					  &
         3x,'o/f ',5x,'yh2r  ',5x,'yo2r',6x,'yh2o',6x,'yo2 ', &
         6x,'yh2 ')			  
      do i=1,nmax
      write(8,24) of(i),yh2r(i),yo2r(i),yh2o(i),yo2(i),	  &
                  yh2(i)
      write(15,80) of(i),yh2r(i),yo2r(i),yh2o(i),yo2(i),yh2(i)
      end do
   24 format(6(1pe10.2))
   80 format(6(1pe12.4))
      close(15)

      write(8,23)
   23 format(//,10x,'FRACOES MASSICAS',//,							  &
         3x,'o/f ',4x,' fmh2r  ',3x,'fmo2r ',4x,'fmh2o ',4x,' fmo2 ', &
         4x,'fmh2  ')
      do i=1,nmax
      write(8,24) of(i),fmh2r(i),fmo2r(i),fmh2o(i),fmo2(i),  &
                  fmh2(i)
      write(16,80) of(i),fmh2r(i),fmo2r(i),fmh2o(i),fmo2(i),fmh2(i)
	  end do
	  close(16)

      write(8,55)
      do i=1,nmax
      write(8,56) of(i),mtotalr(i),mtotalp(i)
      end do
   26 format(3(1pe10.2))


      write(8,50)
   50 format(/////,20x,'RESULTADOS COM DISSOCIACAO',////,     &
                10x,'FRACOES MOLARES',//,					  &
         3x,'o/f ',5x,'  H2O ',5x,' O2 ',6x,' H2 ',6x,'  H ', &
         6x,'  O ',6x,' OH ')
      do i=1,nmax
      write(8,54) of(i),(n(ia,i)/nt(i),ia=1,6)
      write(17,81) of(i),(n(ia,i)/nt(i),ia=1,6)
      end do
   54 format(7(1pe10.2))
   81 format(7(1pe12.4))
      close(17)
 
      write(8,58)
   58 format(///,10x,'FRACOES MOLARES DAS 4 REACOES DE DISSOCIACAO',//, &
         3x,'a/c ',5x,'  R1  ',5x,' R2 ',6x,' R3 ',6x,' R4 ')
      do i=1,nmax
      write(8,59) of(i),(xd(ia,i)/nt(i),ia=1,4)
      write(10,59) of(i),(xd(ia,i)/nt(i),ia=1,4)
      end do
   59 format(5(1pe10.2))
      close(10)

      write(8,53)
   53 format(//,10x,'FRACOES MASSICAS',//,							  &
         3x,'o/f ',5x,'  H2O ',5x,' O2 ',6x,' H2 ',6x,'  H ', &
         6x,'  O ',6x,' OH ')
      do i=1,nmax
      write(8,54) of(i),(fm(ia,i),ia=1,6)
      write(18,81) of(i),(fm(ia,i),ia=1,6)
      end do
	  close(18)
 
      write(8,55)
   55 format(//,10x,'MOL TOTAL',//,				   &
         3x,'o/f ',6x,' reagentes ','  produtos ')
      do i=1,nmax
      write(8,56) of(i),mtotalr(i),mtp(i)
      write(14,56) of(i),mtotalp(i),mtp(i)
      end do
   56 format(3(1pe12.4))
      close(14)

      write(8,31)
   31 format(//,5x,'TEMPERATURA ADIABATICA DE CHAMA',//,  &
                5x,'SEM E COM DISSOCIACAO',//,            &
         3x,'o/f ',5x,'    Tad sem  ','      Tad com')
      do i=1,nmax
      write(8,32) of(i),tad(i),tad2(i)
	  write(9,32) of(i),tad(i),tad2(i)
      end do
   32 format(1pe10.2,2(1pe15.4))
      close(9)
	  close(8)


 1002 call menu(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
        if(i1) chamada=systemqq('wgnuplot tad.gnu')
	    if(i2) chamada=systemqq('wgnuplot fmos.gnu')
	    if(i3) chamada=systemqq('wgnuplot fmoc.gnu')
	    if(i4) chamada=systemqq('wgnuplot fmx.gnu')
	    if(i5) chamada=systemqq('wgnuplot fmas.gnu')
	    if(i6) chamada=systemqq('wgnuplot fmac.gnu')
	    if(i7) chamada=systemqq('wgnuplot mol.gnu')
	    if(i8) goto 1001
	    if(i9) stop
	    if(i10) chamada=systemqq('notepad saida')
        goto 1002


      end



! *** coeficientes ***

      subroutine coeficientes(mol,hz,at)
      implicit real*8(a-h,o-z)
	  real*8 mol(6)
	  dimension at(6,7,2), hz(6)

    do k =1,6
      read(20,*);        read(20,*)   
	  read(20,*) mol(k); read(20,*)
	  do j=1,2
	    do i=1,7;  read(20,*) at(k,i,j); end do; read(20,*)
	  end do
	  read(20,*) hz(k);  read(20,*)
	end do

	  end

! *** caso1 *** combustao completa 

      subroutine caso1(a,e,f,g)
      implicit real*8(a-h,o-z)

      a = 0.5d0
	  e = 1.0d0
	  f = 0.0d0
	  g = 0.0d0

      end

! *** caso2 *** mistura rica em H2

      subroutine caso2(a,e,f,g)
      implicit real*8(a-h,o-z)

      e = 2.0d0*a
	  f = 0.0d0
	  g = 1.0d0 - 2.0d0*a

      end

! *** caso3 *** mistura rica em O2

      subroutine caso3(a,e,f,g)
      implicit real*8(a-h,o-z)

      e = 1.0d0
	  f = a - 0.5d0
	  g = 0.0d0

      end

! *** calcula cp(T) dos produtos segundo NASA TM4513 ***

      subroutine cp (e,f,g,n4,n5,n6,t,cpt,runiv,at,ia)
      implicit real*8(a-h,o-z)
	  dimension at(6,7,2)
	  real*8 n(6),n4,n5,n6

	  n(1)=e; n(2)=f; n(3)=g

	  if(ia.eq.1) then
	     iu = 3
	  else
	     n(4)=n4; n(5)=n5; n(6)=n6
		 iu = 6
	  end if

      if(t.ge.1.0d+3) then
	     j=1
	  else
	     j=2
	  end if

	  cpt = 0.0d0
	  
	  do i=1,iu
	  
	  cpi = at(i,1,j) + at(i,2,j)*t + at(i,3,j)*(t**2)  &
	      + at(i,4,j)*(t**3) + at(i,5,j)*(t**4)
      cpi = cpi*runiv*n(i)

	  cpt = cpt + cpi

	  end do

	  end

! *** calcula h(T) dos produtos segundo NASA TM4513 ***

      subroutine entalpia (e,f,g,n4,n5,n6,t,htp,runiv,at,ia)
      implicit real*8(a-h,o-z)
	  dimension at(6,7,2)
	  real*8 n(6),n4,n5,n6

	  n(1)=e; n(2)=f; n(3)=g

	  if(ia.eq.1) then
	     iu = 3
	  else
	     n(4)=n4; n(5)=n5; n(6)=n6
		 iu = 6
	  end if

      if(t.ge.1.0d+3) then
	     j=1
	  else
	     j=2
	  end if

	  htp = 0.0d0
	  
	  do i=1,iu
	  
	  hti = at(i,1,j) + at(i,2,j)*t/2.0d0 + at(i,3,j)*(t**2)/3.0d0  &
	      + at(i,4,j)*(t**3)/4.0d0 + at(i,5,j)*(t**4)/5.0d0 + at(i,6,j)/t
      hti = hti*t*runiv*n(i)

	  htp = htp + hti

	  end do

	  end

! *** temperatura adiabtica sem dissociao ***

      subroutine t_adiabatica_sem_dissociacao &
	    (e,f,g,hr,tad,nitm,tol,runiv,at)
      implicit real*8(a-h,o-z)
	  dimension at(6,7,2)

      tca = 6.0d+3
	  tc = tca

      do i = 1,nitm
      call entalpia (e,f,g,0.0d0,0.0d0,0.0d0,tc,htp,runiv,at,1)
      ff = htp - hr
      call cp (e,f,g,0.0d0,0.0d0,0.0d0,tc,cpt,runiv,at,1)
      fl = cpt
      tc = tca - ff/fl
	  if(dabs(tc-tca).lt.tol) goto 5
      tca = tc
      end do
    5 continue
      tad = tc
      end

! *** calcula kp(T) dos produtos segundo NASA TM4513 ***

      subroutine gibbs (t,at,k1,k2,k3,k4)
      implicit real*8(a-h,o-z)
	  dimension at(6,7,2),g(6)
      real*8 k1,k2,k3,k4

      if(t.ge.1.0d+3) then
	     j=1
	  else
	     j=2
	  end if
	  
	  do i=1,6
	  
	  g(i) = at(i,1,j)*(1.0d0 - dlog(t)) - at(i,2,j)*t/2.0d0      &
	       - at(i,3,j)*(t**2)/6.0d0 - at(i,4,j)*(t**3)/12.0d0     &
		   - at(i,5,j)*(t**4)/20.0d0 + at(i,6,j)/t - at(i,7,j)

	  end do

      g1 = g(4) + g(6) - g(1);		k1 = dexp(-g1)

      g2 = 2.0d0*g(4) - g(3);		k2 = dexp(-g2)

      g3 = 2.0d0*g(5) - g(2);		k3 = dexp(-g3)

      g4 = g(5) + g(4) - g(6);		k4 = dexp(-g4)

	  end

! *** temperatura adiabtica com dissociao ***

      subroutine t_adiabatica_com_dissociacao                 &
	     (hr,tad2,pt,e,f,g,x1,x2,x3,x4,n1,n2,n3,n4,n5,n6,     &
		  nt,nitm,tol,nitm2,tol2,runiv,at,cr1,cr2,cr3,cr4)
      implicit real*8(a-h,o-z)
	  dimension at(6,7,2)
      real*8 k1,k2,k3,k4,n1,n2,n3,n4,n5,n6,nt

      t1 = 1000.0d0
      t2 = 6000.0d0

      tma = t1
      tm = 0.5d0*(t1+t2)

      do i = 1,nitm
      call gibbs (tm,at,k1,k2,k3,k4)
      call moles (k1,k2,k3,k4,pt,e,f,g,              &
	              n1,n2,n3,n4,n5,n6,x1,x2,x3,x4,     &
		          nt,nitm2,tol2,cr1,cr2,cr3,cr4)
      call entalpia (n1,n2,n3,n4,n5,n6,tm,htp,runiv,at,2)
      dh = htp - hr
      if(dh.lt.0.0d0) then
         t1 = tm
      else
         t2 = tm
      end if
      if(dabs(tm-tma).lt.tol) goto 5
      tma = tm
      tm = 0.5d0*(t1+t2)
      end do
    5 continue
	  tad2 = tm

      end
 
! *** moles ***

      subroutine moles (k1,k2,k3,k4,pt,e,f,g,            &
	                    n1,n2,n3,n4,n5,n6,x1,x2,x3,x4,   &
					    nt,nitm,tol,cr1,cr2,cr3,cr4)
      implicit real*8(a-h,o-z)

      real*8 k1,k2,k3,k4,n1,n2,n3,n4,n5,n6,nt,nta

	  x1 = 0.0d0
	  x2 = 0.0d0
	  x3 = 0.0d0
	  x4 = 0.0d0

      x1a = x1
      x2a = x2
      x3a = x3
	  x4a = x4

      nt = e + f + g + x1 + x2 + x3 + x4

      do j=1,nitm       ! resolve os coeficientes x para T dado

! Reao 1:  H2O ---> H + OH
      a11 = 2.0d0*x2 + x4
	  a12 = - x4
	  b11 = pt
	  b12 = b11*(a11+a12)+k1*nt
	  b13 = b11*a11*a12-k1*nt*e
	  do i1=1,nitm
        fx1 = b11*(x1**2) + b12*x1  + b13
	    flx1 = 2.0d0*b11*x1 + b12
	    x1 = x1a - fx1/flx1 
        if(dabs(x1-x1a).le.tol) goto 11
	    x1a = x1
      end do
   11 continue

! Reao 2:  H2 ---> 2H
      a21 = x1 + x4
	  b21 = 4.0d0*pt
	  b22 = b21*a21+k2*nt
	  b23 = pt*(a21**2)-k2*nt*g
	  do i2=1,nitm
        fx2 = b21*(x2**2) + b22*x2 + b23
	    flx2 = 2.0d0*b21*x2 + b22
	    x2 = x2a - fx2/flx2 
        if(dabs(x2-x2a).le.tol) goto 12
	    x2a = x2
      end do
   12 continue

! Reao 3:  O2 ---> 2O
      a31 = x4
	  b31 = 4.0d0*pt
	  b32 = b31*a31+k3*nt
	  b33 = pt*(a31**2)-k3*nt*f
	  do i3=1,nitm
        fx3 = b31*(x3**2) + b32*x3  + b33
	    flx3 = 2.0d0*b31*x3 + b32
	    x3 = x3a - fx3/flx3 
        if(dabs(x3-x3a).le.tol) goto 13
	    x3a = x3
      end do
   13 continue

! Reao 4:  OH ---> O + H
      a41 = x1
      a42 = x1+2.0d0*x2
	  a43 = 2.0d0*x3
      b41 = pt
	  b42 = pt*(a42+a43)+k4*nt
	  b43 = pt*(a42*a43)-k4*nt*a41
	  do i4=1,nitm
        fx4 = b41*(x4**2) + b42*x4  + b43
	    flx4 = 2.0d0*b41*x4 + b42
	    x4 = x4a - fx4/flx4 
        if(dabs(x4-x4a).le.tol) goto 14
	    x4a = x4
      end do
   14 continue

	  nta = nt
      nt = e + f + g + x1 + x2 + x3 + x4

      if(dabs(nt-nta).le.tol) goto 3

      end do          ! j
    3 continue

      x1 = x1*cr1
      x2 = x2*cr2
      x3 = x3*cr3
	  x4 = x4*cr4

      n1 = e - x1
	  n2 = f - x3
	  n3 = g - x2
	  n4 = x1 + 2.0d0*x2 + x4
	  n5 = 2.0d0*x3 + x4
	  n6 = x1-x4

      end

